/****************************************************************************
**
** SPDX-License-Identifier: BSD-2-Clause-Patent
**
** SPDX-FileCopyrightText: Copyright (c) 2022 SoftAtHome
**
** Redistribution and use in source and binary forms, with or
** without modification, are permitted provided that the following
** conditions are met:
**
** 1. Redistributions of source code must retain the above copyright
** notice, this list of conditions and the following disclaimer.
**
** 2. Redistributions in binary form must reproduce the above
** copyright notice, this list of conditions and the following
** disclaimer in the documentation and/or other materials provided
** with the distribution.
**
** Subject to the terms and conditions of this license, each
** copyright holder and contributor hereby grants to those receiving
** rights under this license a perpetual, worldwide, non-exclusive,
** no-charge, royalty-free, irrevocable (except for failure to
** satisfy the conditions of this license) patent license to make,
** have made, use, offer to sell, sell, import, and otherwise
** transfer this software, where such license applies only to those
** patent claims, already acquired or hereafter acquired, licensable
** by such copyright holder or contributor that are necessarily
** infringed by:
**
** (a) their Contribution(s) (the licensed copyrights of copyright
** holders and non-copyrightable additions of contributors, in
** source or binary form) alone; or
**
** (b) combination of their Contribution(s) with the work of
** authorship to which such Contribution(s) was added by such
** copyright holder or contributor, if, at the time the Contribution
** is added, such addition causes such combination to be necessarily
** infringed. The patent license shall not apply to any other
** combinations which include the Contribution.
**
** Except as expressly stated above, no rights or licenses from any
** copyright holder or contributor is granted under this license,
** whether expressly, by implication, estoppel or otherwise.
**
** DISCLAIMER
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
** CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
** INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
** MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
** DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR
** CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
** USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
** AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
** LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
** ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
**
****************************************************************************/

#ifndef __SWL_AP_H__
#define __SWL_AP_H__

#include <stdint.h>

#include "swl_staCap.h"

typedef enum {
    SWL_BSSID_INFO_AP_NOT_REACHABLE,
    SWL_BSSID_INFO_AP_UNKNOWN,
    SWL_BSSID_INFO_AP_REACHABLE,
    SWL_BSSID_INFO_SECURITY_COPY,
    SWL_BSSID_INFO_KEY_SCOPE_COPY,
    SWL_BSSID_INFO_CAP_SPECTRUM_MANAGEMENT,
    SWL_BSSID_INFO_CAP_QOS,
    SWL_BSSID_INFO_CAP_APSD,
    SWL_BSSID_INFO_CAP_RADIO_MEASUREMENT,
    SWL_BSSID_INFO_CAP_DELAYED_BA,
    SWL_BSSID_INFO_CAP_IMMEDIATE_BA,
    SWL_BSSID_INFO_MOBILITY_DOMAIN,
    SWL_BSSID_INFO_HIGH_THROUGHPUT,
    SWL_BSSID_INFO_VERY_HIGH_THROUGHPUT
} swl_bssidInfo_e;

#define M_SWL_BSSID_INFO_AP_NOT_REACHABLE         (1 << SWL_BSSID_INFO_AP_NOT_REACHABLE)
#define M_SWL_BSSID_INFO_AP_UNKNOWN               (2 << SWL_BSSID_INFO_AP_NOT_REACHABLE)
#define M_SWL_BSSID_INFO_AP_REACHABLE             (M_SWL_BSSID_INFO_AP_NOT_REACHABLE | M_SWL_BSSID_INFO_AP_UNKNOWN)
#define M_SWL_BSSID_INFO_SECURITY_COPY            (1 << (SWL_BSSID_INFO_SECURITY_COPY - 1))
#define M_SWL_BSSID_INFO_KEY_SCOPE_COPY           (1 << (SWL_BSSID_INFO_KEY_SCOPE_COPY - 1))
#define M_SWL_BSSID_INFO_CAP_SPECTRUM_MANAGEMENT  (1 << (SWL_BSSID_INFO_CAP_SPECTRUM_MANAGEMENT - 1))
#define M_SWL_BSSID_INFO_CAP_QOS                  (1 << (SWL_BSSID_INFO_CAP_QOS - 1))
#define M_SWL_BSSID_INFO_CAP_APSD                 (1 << (SWL_BSSID_INFO_CAP_APSD - 1))
#define M_SWL_BSSID_INFO_CAP_RADIO_MEASUREMENT    (1 << (SWL_BSSID_INFO_CAP_RADIO_MEASUREMENT - 1))
#define M_SWL_BSSID_INFO_CAP_DELAYED_BA           (1 << (SWL_BSSID_INFO_CAP_DELAYED_BA - 1))
#define M_SWL_BSSID_INFO_CAP_IMMEDIATE_BA         (1 << (SWL_BSSID_INFO_CAP_IMMEDIATE_BA - 1))
#define M_SWL_BSSID_INFO_MOBILITY_DOMAIN          (1 << (SWL_BSSID_INFO_MOBILITY_DOMAIN - 1))
#define M_SWL_BSSID_INFO_HIGH_THROUGHPUT          (1 << (SWL_BSSID_INFO_HIGH_THROUGHPUT - 1))
#define M_SWL_BSSID_INFO_VERY_HIGH_THROUGHPUT     (1 << (SWL_BSSID_INFO_VERY_HIGH_THROUGHPUT - 1))
typedef uint32_t swl_bssidInfo_m;

typedef enum {
    SWL_IEEE80211_DEAUTH_REASON_NONE=0,
    SWL_IEEE80211_DEAUTH_REASON_UNSPECIFIED=1,
    SWL_IEEE80211_DEAUTH_REASON_AUTH_NO_LONGER_VALID=2,
    SWL_IEEE80211_DEAUTH_REASON_STA_LEFT_IBSS=3,
    SWL_IEEE80211_DEAUTH_REASON_STA_INACTIVITY=4,
    SWL_IEEE80211_DEAUTH_REASON_UNABLE_TO_HANDLE_STA=5,
    SWL_IEEE80211_DEAUTH_REASON_CLASS2_FRAME_NONAUTHENTICATED_STA=6,
    SWL_IEEE80211_DEAUTH_REASON_Class3_FRAME_NONASSOCIATED_STA=7,
    SWL_IEEE80211_DEAUTH_REASON_STA_LEFT_BSS=8,
    SWL_IEEE80211_DEAUTH_REASON_CLIENT_NOTAUTHORIZED=9,
    SWL_IEEE80211_DEAUTH_REASON_UNSUPPORTED_POWER_CAPABILITY_ELEMENT=10,
    SWL_IEEE80211_DEAUTH_REASON_UNSUPPORTED_CHANNELS_ELEMENT=11,
    SWL_IEEE80211_DEAUTH_REASON_BTM=12,
    SWL_IEEE80211_DEAUTH_REASON_INVALID_IE=13,
    SWL_IEEE80211_DEAUTH_REASON_MIC_FAILURE=14,
    SWL_IEEE80211_DEAUTH_REASON_4WAY_HANDSHAKE_TIMEOUT=15,
    SWL_IEEE80211_DEAUTH_REASON_GROUPKEY_HANDSHAKE_TIMEOUT=16,
    SWL_IEEE80211_DEAUTH_REASON_WRONG_4WAY_HANDSHAKE_IE=17,
    SWL_IEEE80211_DEAUTH_REASON_INVALID_GROUP_CIPHER=18,
    SWL_IEEE80211_DEAUTH_REASON_INVALID_PAIRWIZE_CIPHER=19,
    SWL_IEEE80211_DEAUTH_REASON_INVALID_AKMP=20,
    SWL_IEEE80211_DEAUTH_REASON_UNSUPPORTED_RSNE_VERSION=21,
    SWL_IEEE80211_DEAUTH_REASON_INVALID_RSNE_CAPS=22,
    SWL_IEEE80211_DEAUTH_REASON_AUTHENTICATION_FAILED=23,
    SWL_IEEE80211_DEAUTH_REASON_UNSUPPORTED_CIPHER_SUITE=24,
    SWL_IEEE80211_DEAUTH_REASON_TDLS_TEARDOWN_UNREACHABLE=25,
    SWL_IEEE80211_DEAUTH_REASON_TDLS_TEARDOWN_UNSPECIFIED=26,
    SWL_IEEE80211_DEAUTH_REASON_SSP_REQUESTED_DISASSOC=27,
    SWL_IEEE80211_DEAUTH_REASON_NO_SSP_ROAMING_AGREEMENT=28,
    SWL_IEEE80211_DEAUTH_REASON_BAD_CIPHER_OR_AKM=29,
    SWL_IEEE80211_DEAUTH_REASON_NOT_AUTHORIZED_THIS_LOCATION=30,
    SWL_IEEE80211_DEAUTH_REASON_SERVICE_CHANGE_PRECLUDES_TS=31,
    SWL_IEEE80211_DEAUTH_REASON_UNSPECIFIED_QOS=32,
    SWL_IEEE80211_DEAUTH_REASON_NOT_ENOUGH_BANDWIDTH=33,
    SWL_IEEE80211_DEAUTH_REASON_DISASSOC_LOW_ACK=34,
    SWL_IEEE80211_DEAUTH_REASON_EXCEEDED_TXOP=35,
    SWL_IEEE80211_DEAUTH_REASON_STA_LEAVING=36,
    SWL_IEEE80211_DEAUTH_REASON_END_TS_BA_DLS=37,
    SWL_IEEE80211_DEAUTH_REASON_UNKNOWN_TS_BA=38,
    SWL_IEEE80211_DEAUTH_REASON_TIMEOUT=39,
    SWL_IEEE80211_DEAUTH_REASON_PEERKEY_MISMATCH=45,
    SWL_IEEE80211_DEAUTH_REASON_AUTHORIZED_ACCESS_LIMIT_REACHED=46,
    SWL_IEEE80211_DEAUTH_REASON_EXTERNAL_SERVICE_REQUIREMENTS=47,
    SWL_IEEE80211_DEAUTH_REASON_INVALID_FT_ACTION_FRAME_COUNT=48,
    SWL_IEEE80211_DEAUTH_REASON_INVALID_PMKID=49,
    SWL_IEEE80211_DEAUTH_REASON_INVALID_MDE=50,
    SWL_IEEE80211_DEAUTH_REASON_INVALID_FTE=51,
    SWL_IEEE80211_DEAUTH_REASON_MESH_PEERING_CANCELLED=52,
    SWL_IEEE80211_DEAUTH_REASON_MESH_MAX_PEERS=53,
    SWL_IEEE80211_DEAUTH_REASON_MESH_CONFIG_POLICY_VIOLATION=54,
    SWL_IEEE80211_DEAUTH_REASON_MESH_CLOSE_RCVD=55,
    SWL_IEEE80211_DEAUTH_REASON_MESH_MAX_RETRIES=56,
    SWL_IEEE80211_DEAUTH_REASON_MESH_CONFIRM_TIMEOUT=57,
    SWL_IEEE80211_DEAUTH_REASON_MESH_INVALID_GTK=58,
    SWL_IEEE80211_DEAUTH_REASON_MESH_INCONSISTENT_PARAMS=59,
    SWL_IEEE80211_DEAUTH_REASON_MESH_INVALID_SECURITY_CAP=60,
    SWL_IEEE80211_DEAUTH_REASON_MESH_PATH_ERROR_NO_PROXY_INFO=61,
    SWL_IEEE80211_DEAUTH_REASON_MESH_PATH_ERROR_NO_FORWARDING_INFO=62,
    SWL_IEEE80211_DEAUTH_REASON_MESH_PATH_ERROR_DEST_UNREACHABLE=63,
    SWL_IEEE80211_DEAUTH_REASON_MAC_ADDRESS_ALREADY_EXISTS_IN_MBSS=64,
    SWL_IEEE80211_DEAUTH_REASON_MESH_CHANNEL_SWITCH_REGULATORY_REQ=65,
    SWL_IEEE80211_DEAUTH_REASON_MESH_CHANNEL_SWITCH_UNSPECIFIED=66,
    SWL_IEEE80211_DEAUTH_REASON_TRANSMISSION_LINK_ESTABLISHMENT_FAILED=67,
    SWL_IEEE80211_DEAUTH_REASON_ALTERATIVE_CHANNEL_OCCUPIED=68,
    SWL_IEEE80211_DEAUTH_REASON_POOR_RSSI_CONDITIONS=71
} swl_IEEE80211deauthReason_ne;

#endif /* __SWL_AP_H__ */
